#!/bin/sh

# This script should create a basic documentation file with a module from the
# formhandler-package (http://formhandler.sourceforge.net)

dir=".."

# The argument is the name for the module

function usage() {
	echo "Usage: `basename $0` <modulename>"
	exit 1
}

if [ "$1" = "" ]; then
	usage
fi

module=$1
file=$$_${module}_tmp.html

echo "$dir/${module}.mod.php -> $file "

#cat <template_header.html >$file
echo "<table border=1>" >>$file
grep "new Option" $dir/${module}.mod.php \
	|cut -f2 -d\( \
	|cut -f2 -d\" \
	|sed "s/^/<tr><td>/" \
	|sed "s/:/<br>/g" \
	>>$file
echo "</table>" >>$file

#cat <template_footer.html >>$file



