<?
/*
 * Message:
 * This is a dummy class that gets extended by DebugMessage and
 * ErrorMessage
 */

define("UNKNOWN", "unknown"); // default for emitted modulenames
define("DEFAULT_LEVEL", "1");

define("MOD_DISPLAY","display"); // Werkt niet meer ?

include_once("translation.inc.php");

class Message extends ModuleBase {
	var $name = "Message";
	var $messages = array();
	var $enabled = false; // Messages are disabled by default
	var $noop; // Stands for No Operation, that is no action
	//var $show_level = DEFAULT_LEVEL;
	var $translator;
	var $shown = false;
	var $content;

	function Message() {
		global $wrap_up_mods,$name; 
		// Don't know why, but is needed, because ...
		// ... $GLOBAL['name'] is not working.
		//$GLOBAL['wrap_up_mods'][$GLOBAL['name']] = 'wrap_up';
		$wrap_up_mods[$name] = 'wrap_up'; // local wrap_up function
		//echo $name ."[".$this->id."]: " . $wrap_up_mods[$name] ."<br>";
		$this->translator = new Translator(TRANSLATE_BY_DEFAULT);
		$this->ModuleBase();
	}

	function execlevel() {
	}

	function set_noop($bool) {
		$this->noop=$bool;
	}

	function noop() {
		return $this->noop;
	}
		
	//function message_added($level) {
	function message_added($msglevel,$module="",$message="") {
		// In a subclass add functionality after a message is added.
	}

	function add_message($message,$module=UNKNOWN,$msglevel=DEFAULT_LEVEL) {
		// Add a message to the debug messages-base
		$this->messages[] = $module . "[" . $msglevel . "]: $message";
		$this->message_added($msglevel);
	}

	function addmessage($level) {
		// always show messages, overridden for debug to show only messages
		// till specific messagelevel. see debug.mes.php and debug.mod.php
		return true;
	}

	// New add_message function
	function add($msglevel,$module,$message,$var1="",$var2="",$var3="",$var4="",$var5="",$var6="",$var7="",$var8="",$var9="",$var10="",$var11="",$var12="") {
		$var = array(1=>$var1,2=>$var2,3=>$var3,4=>$var4,5=>$var5,6=>$var6,7=>$var7,8=>$var8,9=>$var9,10=>$var10,11=>$var11,12=>$var12);
		while (list($name,$value) = each($var)) {
			$var[$name] = "<font color=red>$value</font>";
		}
		if ($this->addmessage($msglevel)) {
			$new_message = $this->translator->translate($message,$var[1],$var[2],$var[3],$var[4],$var[5],$var[6],$var[7],$var[8],$var[9],$var[10],$var[11],$var[12]);
			$this->messages[] = "$module [ $msglevel ]: $new_message";
		}
		$this->message_added($msglevel,$module,$new_message);
		$this->shown=false;
	}

	function message_array($m_array) {
		// Add an array of messages to the debug message-base
		reset($m_array);
		while (list($module,$message) = each($m_array)) {
			//$this->add_message($message,$module);
			$this->add(-1,$module,$message);
		}
	}

	function display() {
		global $formHandler;
		while (list($name,$value) = each($this->messages)) {
			$content .= "<li><font color=blue>$name</font>: $value\n";
		}
		if (!$formHandler->isset_content($this->content)) {
			$formHandler->set_content($content,$this->content);
		}
		print $formHandler->get_content($this->content,true);
		print $content;
		$this->shown = true;
		$this->messages=array();
	}

	function wrapped_up() {
		// In a subclass add functionality after the script has wrapped up
	}

	// Print messages when breaking up
	function wrap_up() {
		global $modules;
		//echo "wrap_up function called for " . $this->name . "<br>";
		if ($this->enabled&&!$this->shown) {
			//echo $GLOBAL[modules] . " ($modules) en module " . $modules[MOD_DISPLAY];
			//$modules[MOD_DISPLAY]->message_action($this->messages,$this->name());
			//print "<p><li>" . join("\n<li>", $message);
			$this->display();
		}
		$this->wrapped_up();
	}

}

