<?

/* 
 * ModuleBase:
 * This class is the superclass of most of the classes used within this
 * package. All defined variables and methods are aveilable to all these
 * classes.
 */
define("NO_NAME","No name entered");
define("NO_ID","NONE");
define("OPTION_ID","OPTION");
define("MODULE_BASE","MODULE_BASE");

class ModuleBase {
	var $name = NO_NAME;
	var $id = NO_ID;
	var $enabled = true; // Modules are enabled by default

	function ModuleBase() {
		global $debug,$name;

		$message = $this->name . " was created";
		if ($this->id == OPTION_ID) {
			$message = OPTION_ID . " " . $message;
		}

		if ($this->id == MES_DEBUG) {
			/*
			if ($this->enabled) {
				echo "DEBUG: $message<br>\n";
			}
			*/
		} else {
			if ($this->id == NO_ID) {
				$debug->add(-1,MODULE_BASE,"No proper id for object %s",$this->name);
			}
			if ($this->name == NO_NAME) {
				$debug->add(-1,MODULE_BASE,"No proper name for object %s",$this->name);
			}
			$debug->add(-1,MODULE_BASE,$message);
		}
	}

	function enable($bool=true) {
		$this->enabled=$bool;
	}

	function disable() {
		$this->enabled=false;
	}

	/*
	function turn() {
		$this->enabled = !$this->enabled;
	}
	*/

	function is_enabled() {
		return $this->enabled;
	}

	function name() {
		return $this->name;
	}

	function wrap_up() {
	}
}

