<?
/*
 * Configfile: 
 * This file is used for configuration of the form-handler package. Extra
 * modules that you want to use with this package need to be added to the
 * modules array.
 */

// Configure these options:
define("AUTO_CONFIG",true);
define("TEMPLATE_DIR","./templates/");

/* Options in config.mod.php */
// Make options in configfile override options in form
define("CONFIGFILE_OVERRIDE",false);
define("CONFIG_DIR","config");

/* Content defaults content.inc.php */

define("DEFAULT_VAR_CONTENT","%s: %s\n");
define("DEFAULT_VAR_HTMLCONTENT","<li>%s: %s\n");

// Default Title information for content-modules (also via optons)
define("TITLE","Form output");
define("LINE", "------------------------------------------------------------\n");
define("HTML_LINE", "<hr>\n");

// Default headers and footers for content (mail- and displaying output)
define("CONTENT_HEADER", TITLE . "\n" . LINE);
define("CONTENT_FOOTER", LINE . "EndForm");
define("CONTENT_HEADER_HTML", "<HTML>\n<HEAD>\n<TITLE>".TITLE."</TITLE>\n</HEAD>\n<BODY><H1>".TITLE."</H1>\n".HTML_LINE);
define("CONTENT_FOOTER_HTML", HTML_LINE . "<p>EndForm<p></BODY></HTML>");

// Translation function
define("TRANS_BY_DEFAULT",true);

// Ready to go

/**********************************************************************
 * It is better to leave the rest of the file untouched
 **********************************************************************/
// Content definitions
define("CONTENT",1);
define("MAIL_CONTENT",1);
define("DISPLAY_CONTENT",2);
define("ERROR_CONTENT",3);
define("DEBUG_CONTENT",4);
define("REPLY_CONTENT",5);

// Var-array definitions
define("VARS",0);
define("ALL_VARS","VARS");
define("SHOW_VARS",1);
define("SYS_VARS",2);
define("USR_VARS",3);
define("COOKIE_VARS",4);

define("STEP_EXECLEVEL",10); // Number of toplevels
define("MAX_STEPS",3); // Number of sublevels
// Be carefull: when setting smaller than 10. The execnumbers used in the
// modules is build as follows: 10 means runlevel 1 step 0 (first), 19 means
// runlevel 1 step 9 (10th). If MAX_STEPS is set to 9 then 19, 29, 29, etc
// are not executed anymore.
define("MAX_ACTION",3); // Number of executionsteps per module
define("LOCAL_DIR",".");
define("MOD_EXT",".mod.php");
define("DEF_EXT",".def.xml");
	// Because the file xml.inc.php is quite large and may downgrade the
	// performance of the whole script, you can turn of auto-configuration in
	// the configfile.mod.php (must become xml config one day)
// Config-options numbered
define("CFG_AUTO_CONFIG",1);

// Regular expression to recognize an emailaddress
define("REGEX_MAIL","(^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,3}$)");

// Define all boolean false values in options as a regex
define("_FALSE","(false|0)"); // true = !false

// Define addto_vars replace values
define("REPLACE",true);
define("DONT_REPLACE",false);

// The order of the module-list to load is significant. 
$load_modules['modulebase'] = 'modulebase.inc.php'; // Needed for all

// Application message handling
// Because of this definition, object Error can use Debug, but Debug can't
// use Error (in its first function).
$load_modules['message'] = 'message.inc.php'; // Needed for Error and Debug
$load_modules['debug'] = 'debug.mes.php'; // Needed for modules
// Use debugdummy instead of debug if you want to completely turn off
// debugging.
//$load_modules['debug'] = 'debugdummy.mes.php'; // Needed for modules
$load_modules['error'] = 'error.mes.php'; // Needed for modules

// Module interface structure and Option object
$load_modules['module'] = 'module.inc.php';

// Defaults based on class module
// Display class is necessary for debug and error to give output
$load_modules['display'] = 'display.mod.php';
$load_modules['debugopts'] = 'debug.mod.php';
$load_modules['config'] = 'config.mod.php';
$load_modules['mail'] = 'mail.mod.php';

// The actural FormHandler
$load_modules['handler'] = 'formhandler.inc.php'; // FormHandler class



