<?
/*
 * DebugMessage:
 * This message-module creates an interface for the creation and displaying
 * of debug-messages.
 */

define("MES_DEBUG",$name);

define("DB_INIT",-1);
define("DB_ERROR",1);
define("DB_WARN",2);
define("DB_FLOW",3);
define("DB_INPUT",4);
define("DB_CONF",5);
define("DB_XFLOW",6);
define("DB_INFO",7);
define("DB_DEV",8);
define("DB_ALL",9);

#$modules[$name]= new DebugMessage(true,false);
$modules[$name]= new DebugMessage();

class DebugMessage extends Message {
	var $name = "DebugMessage";
	var $id = MES_DEBUG;
	var $level=1; // The level that needs to be shown
	var $debug_file;

	function DebugMessage($enable=false,$noop=false) {
		$this->content = DEBUG_CONTENT;
		$this->enable($enable);
		$this->set_noop($noop);
		$this->Message();
	}

	function set_level($level) {
		if ($level<1) {
			$this->level = 1;
		} else {
			$this->level = $level;
		}
	}

	function set_debug_file($file) {
		// Option to print messages to a file.
		$this->debug_file = $file;
	}

	function addmessage($level) {
		if ($level>$this->level) {
			return false;
		} else {
			return true;
		}
	}

	function wrapped_up() {
		// Print debug-messages to a file and display debug-values when breaking
		// up
		if ($this->debug_file) {
				echo join("\n",$this->messages) . "\n"; // Change to write to file
		}

	}

}

