<?

/*
 * EnvModule:
 * This module makes it possible to view environment variables from the
 * webserver in the mail that is send. This way it is possible to get extra
 * information on the submitter.
 */

define("MOD_ENV",$name);

define("ENV_SEPERATOR",",");
define("DEFAULT_ENV","HTTP_HOST:HTTP_REFERER:HTTP_USER_AGENT");

$modules[$name]= new EnvModule();

class EnvModule extends Module {
	var $name = "EnvModule";
	var $id = MOD_ENV;
	var $execlevel = 16;
	var $vars = array();

	function EnvModule() {
		$this->options[] = new Option("env:env_report","",false,true,DEFAULT_ENV);
		$this->Module();
	}
	
	function before_action() {
		$this->check_options();
		$this->vars = split(ENV_SEPERATOR,$this->options[0]->value);
	}

	function do_action() {
		global $formHandler,$debug;
		$this->action();

		//$content = MAIL_CONTENT;
		//$formHandler->addto_content("Environment variables:\n",$content);
		$env="Environment variables  :\n";
		$extra_vars=array();
		while (list(,$name) = each($this->vars)) {
			global $$name;
			$value = $$name;
			if (is_array($value)) {
				// This needs to be formatted
				$value = fh_serialize($value);
			}
			//$formHandler->addto_vars($name,$value);
			$extra_vars[$name]=$value;
			$env.="$name: $value\n\n";
		}
		//$formHandler->addto_vars($this->options[0]->name,$env);
		$extra_vars[$this->options[0]->name]=$env;
		$formHandler->addto_vars($extra_vars,REPLACE);
	}

	function after_action() {
		$this->clean_up();
	}
}

