<?
/* 
 * Required:
 * This module checks if some set of fields that is defined required is
 * really filled in.
 */

define("MOD_REQUIRED",$name);
define("REQUIRED_SEP",",");

$modules[$name]= new RequiredModule();

class RequiredModule extends Module {
	var $name = "RequiredModule";
	var $id = MOD_REQUIRED;
	var $execlevel = 12;

	function RequiredModule() {
		$this->options[] = new Option("required:require");
		$this->Module();
	}
	
	function before_action() {
		$this->check_options(); // necessary for intergration with class module
	}

	function do_action() {
		global $error,$formHandler;

		$this->action();

		$vars = $formHandler->get_vars(SHOW_VARS);
		$required = strtolower($this->options[0]->value);

		//echo var_dump($this->options[0]) . " $required<br>";

		if (!strpos($required,REQUIRED_SEP)===false) {
			$required = split(REQUIRED_SEP,$required);
			while (list(,$field) = each($required)) {
				if (!isset($vars[$field])||empty($vars[$field]))
					//$error->add_message("Field $field is required, but missing",$this->name,2);
					$error->add(ERR_INP_CONT,$this->name,"Field %s is required, but missing",$field);
			} // end while
		} else {
			if (isset($vars[$required])||empty($vars[$field]))
					//$error->add_message("Field $required is required, but missing",$this->name,2);
					$error->add(ERR_INP_CONT,$this->name,"Field %s is required, but missing",$required);
		} // end if strpos

	} // end function do_action

	function after_action() {
		$this->clean_up();
	}
}

